SystemOrganization addCategory: #Metaprogramacion!

SampleClassToTestProgrammingErrorsDetector subclass: #SampleClassWithNoSubclasses
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!SampleClassWithNoSubclasses methodsFor: 'subclassResponsabilityMethods' stamp: 'AlejandraRodriguez 6/21/2013 18:49'!
anAbstractMethod
	^ self subclassResponsibility ! !

SampleClassToTestProgrammingErrorsDetector subclass: #SampleClassWithOneLevelOfSubclasses
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!SampleClassWithOneLevelOfSubclasses methodsFor: 'subclassResponsabilityMethods' stamp: 'AlejandraRodriguez 6/21/2013 19:55'!
aSubclassDefinedMethod
	^ self subclassResponsibility ! !

!SampleClassWithOneLevelOfSubclasses methodsFor: 'subclassResponsabilityMethods' stamp: 'AlejandraRodriguez 6/21/2013 20:26'!
anAbstractMethod
	^ self subclassResponsibility ! !

SampleClassWithOneLevelOfSubclasses subclass: #SampleOneLevelSubClassA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!SampleOneLevelSubClassA methodsFor: 'inClassDefinedMethods' stamp: 'AlejandraRodriguez 6/21/2013 19:52'!
aSubclassDefinedMethod
	^ 'Ahora estoy definido!!'! !

SampleClassWithOneLevelOfSubclasses subclass: #SampleOneLevelSubClassB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!SampleOneLevelSubClassB methodsFor: 'inClassDefinedMethods' stamp: 'AlejandraRodriguez 6/21/2013 19:53'!
aSubclassDefinedMethod
	^ 'Ahora estoy definido!!'! !

SampleClassToTestProgrammingErrorsDetector subclass: #SampleClassWithTwoLevelsOfSubclasses
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!SampleClassWithTwoLevelsOfSubclasses methodsFor: 'subclassResponsabilityMethods' stamp: 'AlejandraRodriguez 6/21/2013 19:55'!
aSubclassDefinedMethod
	^ self subclassResponsibility ! !

SampleClassWithTwoLevelsOfSubclasses subclass: #SampleTwoLevelSubclassWhitOneSubclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

SampleTwoLevelSubclassWhitOneSubclass subclass: #SampleSubSubclassC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!SampleTwoLevelSubclassWhitOneSubclass methodsFor: 'inClassDefinedMethods' stamp: 'AlejandraRodriguez 6/21/2013 19:55'!
aSubclassDefinedMethod
	^ 'Ahora estoy definido!!'! !

SampleClassWithTwoLevelsOfSubclasses subclass: #SampleTwoLevelSubclassWithTwoSubclasses
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

SampleTwoLevelSubclassWithTwoSubclasses subclass: #SampleSubSubclassD
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!SampleSubSubclassD methodsFor: 'inClassDefinedMethods' stamp: 'AlejandraRodriguez 6/21/2013 19:55'!
aSubclassDefinedMethod
	^ 'Ahora estoy definido!!'! !

SampleTwoLevelSubclassWithTwoSubclasses subclass: #SampleSubSubclassE
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!SampleSubSubclassE methodsFor: 'inClassDefinedMethods' stamp: 'AlejandraRodriguez 6/21/2013 19:55'!
aSubclassDefinedMethod
	^ 'Ahora estoy definido!!'! !

TestCase subclass: #MetaprogramacionTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!MetaprogramacionTests methodsFor: 'methods' stamp: 'AlejandraRodriguez 6/21/2013 20:01'!
abstractMethodForWhomAllOfItsClassOneLevelSubclassesHaveDefinedIt
	^ SampleClassWithOneLevelOfSubclasses>>#aSubclassDefinedMethod! !

!MetaprogramacionTests methodsFor: 'methods' stamp: 'AlejandraRodriguez 6/24/2013 02:25'!
abstractMethodForWhomAllOfItsClassSubclassesHaveDefinedIt
	^ SampleClassWithTwoLevelsOfSubclasses>>#aSubclassDefinedMethod! !

!MetaprogramacionTests methodsFor: 'methods' stamp: 'AlejandraRodriguez 6/21/2013 20:01'!
abstractMethodForWhomItsClassHasNotSubclasses
	^ SampleClassWithNoSubclasses>>#anAbstractMethod! !

!MetaprogramacionTests methodsFor: 'methods' stamp: 'AlejandraRodriguez 6/21/2013 18:51'!
nonAbstractCompiledMethod
	^ SampleClassToTestProgrammingErrorsDetector>>#nonAbstractMethod! !

!MetaprogramacionTests methodsFor: 'tests' stamp: 'AlejandraRodriguez 6/21/2013 18:28'!
test01IfAMethodIsNotAbstractThenItWillBeConsideredDefined

	| aProgrammingErrorsDetector |

	aProgrammingErrorsDetector := ProgrammingErrorsDetector new.
	self deny: (aProgrammingErrorsDetector methodIsUndefinedForSubclases: self nonAbstractCompiledMethod).
	self assert: (aProgrammingErrorsDetector allSubclassesForWhomIsUndefinedTheMethod: self nonAbstractCompiledMethod) isEmpty.! !

!MetaprogramacionTests methodsFor: 'tests' stamp: 'AlejandraRodriguez 6/21/2013 18:57'!
test02IfAMethodIsAbstractAndThereIsNotSubclassesThenItIsUndefinedForSubclassesAndTheListOfSublcassesForWhomIsUndefinedMustBeEmpty

	| aProgrammingErrorsDetector |

	aProgrammingErrorsDetector := ProgrammingErrorsDetector new.
	self assert: (aProgrammingErrorsDetector methodIsUndefinedForSubclases: self abstractMethodForWhomItsClassHasNotSubclasses).
	self assert: (aProgrammingErrorsDetector allSubclassesForWhomIsUndefinedTheMethod: self abstractMethodForWhomItsClassHasNotSubclasses) isEmpty.! !

!MetaprogramacionTests methodsFor: 'tests' stamp: 'AlejandraRodriguez 6/24/2013 02:22'!
test03IfAMethodIsAbstractAndAllOfItsOneLevelSubclassesDefineItThenIsDefinedAndTheListOfSublcassesMustBeEmpty

	| aProgrammingErrorsDetector |

	aProgrammingErrorsDetector := ProgrammingErrorsDetector new.
	self deny: (aProgrammingErrorsDetector methodIsUndefinedForSubclases: self abstractMethodForWhomAllOfItsClassOneLevelSubclassesHaveDefinedIt).
	self assert: (aProgrammingErrorsDetector allSubclassesForWhomIsUndefinedTheMethod: self abstractMethodForWhomAllOfItsClassOneLevelSubclassesHaveDefinedIt) isEmpty.! !

!MetaprogramacionTests methodsFor: 'tests' stamp: 'AlejandraRodriguez 6/24/2013 02:25'!
test04IfAMethodIsAbstractAndAllOfItsAnyLevelSubclassesHaveDefinedItThenIsDefinedAndTheListOfSublcassesMustBeEmpty

	| aProgrammingErrorsDetector |

	aProgrammingErrorsDetector := ProgrammingErrorsDetector new.
	self deny: (aProgrammingErrorsDetector methodIsUndefinedForSubclases: self abstractMethodForWhomAllOfItsClassSubclassesHaveDefinedIt).
	self assert: (aProgrammingErrorsDetector allSubclassesForWhomIsUndefinedTheMethod: self abstractMethodForWhomAllOfItsClassSubclassesHaveDefinedIt) isEmpty.! !

Object subclass: #ProgrammingErrorsDetector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!ProgrammingErrorsDetector methodsFor: 'detectors' stamp: 'AlejandraRodriguez 6/24/2013 02:08'!
allLeavesSubClassesOf: aClass
	^ aClass allSubclasses select: [:aSubClass | aSubClass subclasses isEmpty]! !

!ProgrammingErrorsDetector methodsFor: 'finders' stamp: 'AlejandraRodriguez 6/24/2013 01:53'!
allSubclassesForWhomIsUndefinedTheMethod: aMetaprogramacionTests 
	^ SortedCollection new.! !

!ProgrammingErrorsDetector methodsFor: 'detectors' stamp: 'AlejandraRodriguez 6/24/2013 02:20'!
anySubclassNotDefineTheMethod: aCompiledMethod
	| theLeavesSubClassesOfTheMethod theMethodSelector |
	theLeavesSubClassesOfTheMethod := self allLeavesSubClassesOf:  aCompiledMethod methodClass.
	theMethodSelector := aCompiledMethod selector.
	^ theLeavesSubClassesOfTheMethod isEmpty or: [ theLeavesSubClassesOfTheMethod anySatisfy: [ :aLeaveSubClass | ((aLeaveSubClass whichClassIncludesSelector: theMethodSelector)>>theMethodSelector) isAbstract ] ]
! !

!ProgrammingErrorsDetector methodsFor: 'detectors' stamp: 'AlejandraRodriguez 6/21/2013 20:58'!
isAbstractClass: aClass
	^ (aClass allMethods select: [:aMethod | aMethod isAbstract]) isEmpty  not! !

!ProgrammingErrorsDetector methodsFor: 'detectors' stamp: 'AlejandraRodriguez 6/24/2013 02:07'!
methodIsUndefinedForSubclases: aCompiledMethod 
	^ aCompiledMethod isAbstract and: (self anySubclassNotDefineTheMethod: aCompiledMethod)! !
